function [m,head]=readppm(fil)
// this function reads images in PBM, PGM, PPM (ascii and binary) formats
// fil is a string containing the file name containing the image
head=[]
lignecourante=[]
m=[]
[u,err]=mopen(fil,'rb')
if err<>0 then error('Impossible to open file '+fil),end
// read the type
head=getimgline(u)
h=head
if h~='P'+string([1 2 3 4 5 6]) then
  error('Not a PBM/PGM/PPM file')
end   
ftyp=evstr(part(h,2))


//comments
c='#';
while c=='#',
  lignecourante=getimgline(u)
  head=[head;lignecourante];
  c=part(lignecourante,1)
end; 			
//image size
execstr('sz=['+lignecourante+']')
// number of colors

if and(ftyp<>[1 4]) then 
  execstr('nc='+getimgline(u))
else
  nc=2
end;
if or(ftyp==[3 6]) then 
  nv=3*sz(1)*sz(2),
  m=uint8(0);m(3*sz(1),sz(2))=uint8(0);
else  
  nv=sz(1)*sz(2),
  m=uint8(0);m(sz(1),sz(2))=uint8(0);
end

l=1
if or(ftyp==[1 2 3]) then //ascii files
  mclose(u)
  u=file('open',fil,'old')
  w=read(u,size(head,1),1,'(a)');
  select ftyp
  case 1 then step=35*500;
  case 2 then step=17*1000;
  case 3 then step=15*1000;
  end
  nr=int(nv/step)

  errcatch(62,'continue','nomessage')
  for k=1:nr
    m(l:l+step-1)=uint8(read(u,1,step))
    if iserror(62)<>0 then
      errcatch(-1);errclear(-1)
      pause
      error('End of file reached, check for carriage return at the file end')
    end
    l=l+step
  end
  if nr*step<nv then
    r=nv-nr*step
    m(l:nv)=uint8(read(u,1,nv-l+1))
    if iserror(62)<>0 then
      errcatch(-1);errclear(-1)
      pause
      error('End of file reached, check for carriage return at the file end')
    end
    l=l+r
  end
  errcatch(-1)
  file('close',u)
else
  if ftyp<>4 then // uchar stored
    step=10000
    nr=ceil(nv/step)
    for k=1:nr
      tmp=mget(step,'uc',u);nt=size(tmp,'*')
      if tmp==[] then pause,end
      m(l:l+nt-1)=uint8(tmp);l=l+nt
    end
  else //bits are stored
    error('Binary Black and White  files cannot be read yet')
    step=1000
    nr=ceil(nv/(8*step))
    f=uint8(2.^(0:7))
    for k=1:nr
      tmp=uint8(mget(step,'uc',u));
      if tmp==[] then pause,end
      tmp=matrix([tmp&f(1);
	   (tmp&f(2));
	   (tmp&f(3));
	   (tmp&f(4));
	   (tmp&f(5));
           (tmp&f(6));
	   (tmp&f(7));
	   (tmp&f(8))],1,-1);
       tmp(find(tmp>uint8(1)))=uint8(1) //ne marche pas
       nt=size(tmp,'*')
       m(l:l+nt-1)=tmp
      l=l+nt;
    end
    m(find(m>uint8(1)))=uint8(1)

  end
  mclose(u)
end
endfunction

function l=getimgline(u)
h=[]
while %t 
 c=mget(1,'uc',u)
 if c==10 then break,end
 h=[h c]
end
l=ascii(h)
endfunction



